All of lore.kernel.org
 help / color / mirror / Atom feed
From: Jeff Cody <jcody@redhat.com>
To: qemu-devel@nongnu.org
Cc: kwolf@redhat.com, benoit@irqsave.net, stefanha@redhat.com
Subject: [Qemu-devel] [PATCH v2 3/5] block: qemu-iotests - test for live migration
Date: Wed,  9 Apr 2014 22:41:56 -0400	[thread overview]
Message-ID: <8041b33829228870637fe6d066484a53a4aa079d.1397097046.git.jcody@redhat.com> (raw)
In-Reply-To: <cover.1397097046.git.jcody@redhat.com>
In-Reply-To: <cover.1397097046.git.jcody@redhat.com>

This is an initial, simple live migration test from one
running VM to another, using monitor commands.

This is also an example on using the new common.qemu functions
for controlling multiple running qemu instances, for tests that
need a live qemu vm.

Signed-off-by: Jeff Cody <jcody@redhat.com>
---
 tests/qemu-iotests/089     | 97 ++++++++++++++++++++++++++++++++++++++++++++++
 tests/qemu-iotests/089.out | 20 ++++++++++
 tests/qemu-iotests/group   |  1 +
 3 files changed, 118 insertions(+)
 create mode 100755 tests/qemu-iotests/089
 create mode 100644 tests/qemu-iotests/089.out

diff --git a/tests/qemu-iotests/089 b/tests/qemu-iotests/089
new file mode 100755
index 0000000..22a7cf1
--- /dev/null
+++ b/tests/qemu-iotests/089
@@ -0,0 +1,97 @@
+#!/bin/bash
+#
+# Live migration test
+#
+# Performs a migration from one VM to another via monitor commands
+#
+# Copyright (C) 2014 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+# creator
+owner=jcody@redhat.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+status=1	# failure is the default!
+
+MIG_FIFO="${TEST_DIR}/migrate"
+
+_cleanup()
+{
+    rm -f "${MIG_FIFO}"
+    _cleanup_qemu
+	_cleanup_test_img
+
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+. ./common.qemu
+
+_supported_fmt qcow2
+_supported_proto file
+_supported_os Linux
+
+size=1G
+
+IMGOPTS="cluster_size=512" _make_test_img $size
+
+mkfifo "${MIG_FIFO}"
+
+echo
+echo === Starting QEMU VM1 ===
+echo
+
+qemu_comm_method="monitor"
+_launch_qemu -drive file="${TEST_IMG}",cache=none,id=disk
+h1=$QEMU_HANDLE
+
+echo
+echo === Starting QEMU VM2 ===
+echo
+_launch_qemu -drive file="${TEST_IMG}",cache=none,id=disk \
+             -incoming "exec: cat '${MIG_FIFO}'"
+h2=$QEMU_HANDLE
+
+echo
+echo === VM 1: Migrate from VM1 to VM2  ===
+echo
+
+silent=yes
+_send_qemu_cmd $h1 'qemu-io disk "write 0 4M"' "(qemu)"
+echo "vm1: qemu-io disk write complete"
+_send_qemu_cmd $h1 "migrate \"exec: cat > '${MIG_FIFO}'\"" "(qemu)"
+echo "vm1: live migration started"
+qemu_cmd_repeat=20 _send_qemu_cmd $h1 "info migrate" "completed"
+echo "vm1: live migration completed"
+
+echo
+echo === VM 2: Post-migration, write to disk, verify running ===
+echo
+
+_send_qemu_cmd $h2 'qemu-io disk "write 4M 1M"' "(qemu)"
+echo "vm2: qemu-io disk write complete"
+qemu_cmd_repeat=20 _send_qemu_cmd $h2 "info status" "running"
+echo "vm2: qemu process running successfully"
+
+
+echo "*** done"
+rm -f $seq.full
+status=0
diff --git a/tests/qemu-iotests/089.out b/tests/qemu-iotests/089.out
new file mode 100644
index 0000000..4e9e6c9
--- /dev/null
+++ b/tests/qemu-iotests/089.out
@@ -0,0 +1,20 @@
+QA output created by 089
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=1073741824 
+
+=== Starting QEMU VM1 ===
+
+
+=== Starting QEMU VM2 ===
+
+
+=== VM 1: Migrate from VM1 to VM2 ===
+
+vm1: qemu-io disk write complete
+vm1: live migration started
+vm1: live migration completed
+
+=== VM 2: Post-migration, write to disk, verify running ===
+
+vm2: qemu-io disk write complete
+vm2: qemu process running successfully
+*** done
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
index 864643d..73e6b5d 100644
--- a/tests/qemu-iotests/group
+++ b/tests/qemu-iotests/group
@@ -95,3 +95,4 @@
 086 rw auto quick
 087 rw auto
 088 rw auto
+089 rw auto
-- 
1.8.3.1

  parent reply	other threads:[~2014-04-10  2:42 UTC|newest]

Thread overview: 19+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2014-04-10  2:41 [Qemu-devel] [PATCH v2 0/5] Add common QEMU control functionality to qemu-iotests Jeff Cody
2014-04-10  2:41 ` [Qemu-devel] [PATCH v2 1/5] block: qemu-iotests - add common.qemu, for bash-controlled qemu tests Jeff Cody
2014-04-10  5:27   ` Fam Zheng
2014-04-10 19:07     ` Jeff Cody
2014-04-10  2:41 ` [Qemu-devel] [PATCH v2 2/5] block: qemu-iotests - update 085 to use common.qemu Jeff Cody
2014-04-10  6:10   ` Fam Zheng
2014-04-10 19:28     ` Jeff Cody
2014-04-10  2:41 ` Jeff Cody [this message]
2014-04-10  6:16   ` [Qemu-devel] [PATCH v2 3/5] block: qemu-iotests - test for live migration Fam Zheng
2014-04-10 11:10     ` Jeff Cody
2014-04-10  2:41 ` [Qemu-devel] [PATCH v2 4/5] block: qemu-iotests - fix image cleanup when using spaced pathnames Jeff Cody
2014-04-10  7:53   ` Fam Zheng
2014-04-10 12:53     ` Jeff Cody
2014-04-10 14:43       ` Eric Blake
2014-04-10 14:48         ` Eric Blake
2014-04-10 18:09           ` Jeff Cody
2014-04-11  0:59             ` Fam Zheng
2014-04-10  2:41 ` [Qemu-devel] [PATCH v2 5/5] block: qemu-iotests: make test 019 and 086 work with " Jeff Cody
2014-04-10  7:51   ` Fam Zheng

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=8041b33829228870637fe6d066484a53a4aa079d.1397097046.git.jcody@redhat.com \
    --to=jcody@redhat.com \
    --cc=benoit@irqsave.net \
    --cc=kwolf@redhat.com \
    --cc=qemu-devel@nongnu.org \
    --cc=stefanha@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.